package search;

public class Search {

    public static double[] makeArray(int size) {
        double[] data = new double[size];
        for (int i = 0; i < data.length; i++) {
            data[i] = Math.random();
        } //for
        return data;
    } //makeArray()

    private static void printArray(double[] data) {
        for (int i = 0; i < data.length; i++) {
            System.out.printf("%2d: %8.2f\n", i, data[i]);
        } //for
        System.out.println();
    } //printArray()

    private static double minimum(double[] data) {
        double bestGuessSoFar = data[0];
        for (int i = 1; i < data.length; i++) {
            if (data[i] < bestGuessSoFar) {
                bestGuessSoFar = data[i];
            } //if
        } // for
        return bestGuessSoFar;
    } //minimum ( double [] )

    private static double minimum(double[] data, int start) {
        double bestGuessSoFar = data[start];
        for (int i = start + 1; i < data.length; i++) {
            if (data[i] < bestGuessSoFar) {
                bestGuessSoFar = data[i];
            } //if
        } // for
        return bestGuessSoFar;
    } //minimum ( double [] )

    private static int positionOfMinimum(double[] data) {
        int bestGuessSoFar = 0;
        for (int i = 1; i < data.length; i++) {
            if (data[i] < data[bestGuessSoFar]) {
                bestGuessSoFar = i;
            } //if
        } //for
        return bestGuessSoFar;
    } //positionOfMinimum ( double [] )

    private static int positionOfMinimum(double[] data, int start) {
        int bestGuessSoFar = start;
        for (int i = start + 1; i < data.length; i++) {
            if (data[i] < data[bestGuessSoFar]) {
                bestGuessSoFar = i;
            } //if
        } //for
        return bestGuessSoFar;
    } //positionOfMinimum ( double [] )

    public static double sum(double[] data) {
        double result = 0.0;
        for (double x : data) {
            result += x;
        }
        return result;
    } // sum( double [] )

    public static double[] makePDF(double[] data) {
        double[] result = new double[data.length];
        double total = sum(data);
        for (int i = 0; i < data.length; i++) {
            result[i] = data[i] / total;
        } // for
        return result;
    } // makePDF( double [] )

    public static double[] makeCDF(double[] pdf) {
        double[] cdf = new double[pdf.length];

        cdf[0] = pdf[0];
        for (int i = 1; i < pdf.length; i++) {
            cdf[i] = cdf[i - 1] + pdf[i];
        } // for

        return cdf;
    } // makeCDF( double [] )

    public static int selectEvent(double[] cdf) {
        int event = 0;
        double randomNumber = Math.random();
        while (event < cdf.length
                && randomNumber > cdf[event]) {
            event++;
        } // while
        return event;
    } // selectEvent( double [] )

    public static void main(String[] args) {
        double[] numbers = makeArray(3);
        printArray(numbers);

        System.out.printf("Sum = %6.2f\n",
                sum(numbers));
        double[] pdf = makePDF(numbers);
        printArray(pdf);
        System.out.printf("Sum = %6.2f\n",
                sum(pdf));

        double[] cdf = makeCDF(pdf);
        printArray(cdf);
        
        double [] dist = { 0.10, 0.60, 1.00 };
        
        for( int i = 0; i < 10; i++ ) {
            for( int j = 0; j < 10; j++ ) {
                System.out.print( selectEvent(dist) + " ");
            } // for
            System.out.println();
        } // for

//        System.out.printf("Smallest value = %8.2f\n" , 
//                minimum (numbers) );
//        System.out.println( "Position of smallest value: " + 
//                positionOfMinimum (numbers) );
//        
//        System.out.println( "Look at second half of list.");
//        System.out.printf("Smallest value = %8.2f\n",
//                minimum(numbers, numbers.length/2));
//        System.out.println("Position of smallest value: " +
//                positionOfMinimum(numbers,numbers.length/2));
    } //main( String [] )
} //Search
